<template>
  <div>
    <qrcode-stream @decode="onDecode" :camera="{ facingMode: 'user' }"></qrcode-stream>
    <v-snackbar
      v-model="snackbar"
      :color="notify && notify.color"
      :timeout="notify && notify.timeout"
    >
      {{ notify && notify.message }}
      <v-btn dark flat @click="snackbar = false">Ok</v-btn>
    </v-snackbar>
  </div>
</template>

<script>
import { Container, Draggable } from "vue-smooth-dnd";
import GqlList from "@/components/GqlList";
import { QrcodeStream } from "vue-qrcode-reader";
import gql from "graphql-tag";
import { timeout } from "q";

export default {
  components: { Container, Draggable, GqlList, QrcodeStream },
  data() {
    return {
      department: this.$route.params.dpt,
      notify: null,
      snackbar: null
    };
  },
  mounted() {},
  methods: {
    async onDecode(val) {
      try {
        this.loading = true;
        if (
          /^[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/.test(
            val
          ) &&
          this.save
        ) {
          const result = await this.save(val);

          console.log(result.data.updateRecordLocation.name);

          this.notify = {
            color: "success",
            message: `Registered successfuly record: ${
              result.data.updateRecordLocation.name
            } at ${this.department}`,
            timeout: 5000
          };
          this.snackbar = true;
        }
      } catch (e) {
        console.error(e);
        if (e.networkError)
          this.notify = {
            color: "error",
            message: "An error has ocurred"
          };
        else if (e.graphQLErrors)
          this.notify = {
            color: "warning",
            message: e.graphQLErrors[0].message || "Error in the request"
          };
        else
          this.notify = {
            color: "error",
            message: "An error has ocurred"
          };
        this.snackbar = true;
      } finally {
        this.loading = false;
      }
    },
    async save(val) {
      // Run mutation
      const result = await this.$apollo.mutate({
        // Query
        mutation: gql`
          mutation updateLocation($id: ID!, $dpt: Department!) {
            updateRecordLocation(id: $id, location: { department: $dpt }) {
              id
              name
            }
          }
        `,
        // Parameters
        variables: {
          id: val,
          dpt: this.department
        }
      });

      return result;
    },
    createFreshman(evn) {
      const turns = [];
      for (let i = 0; i < this.turns; i++) turns.push({ value: "" });
      this.freshmen.push({ name: this.newName, turns });
      this.newName = "";
    },
    calculatePossibilities() {
      const departments = [
        { id: "sec", min: 0, max: 3 },
        { id: "enf", min: 0, max: 4 },
        { id: "od", min: 0, max: 2 },
        { id: "olhos", min: 0, max: 0 },
        { id: "pf", min: 3, max: 4 },
        { id: "pt", min: 3, max: 5 },
        { id: "pm", min: 2, max: 4 },
        { id: "pod", min: 3, max: 5 },
        { id: "nut", min: 4, max: 4 },
        { id: "cme", min: 3, max: 4 },
        { id: "tc", min: 0, max: 0 }
      ];
      const rules = [
        { type: "freshmen_limit", department: "olhos" },
        { type: "freshmen_limit", department: "tc" },
        { type: "freshmen_limit", department: "cme" },
        { type: "freshmen_limit", department: "nut" },
        { type: "freshmen_limit", department: "enf " },
        { type: "freshmen_limit", department: "od" },
        { type: "freshmen_limit", department: "sec" },
        { type: "freshmen_limit", department: "pod" },
        { type: "freshmen_limit", department: "pm" },
        { type: "freshmen_limit", department: "pf" },
        { type: "freshmen_limit", department: "pt" },
        { type: "no_repeat" } // Rule avoiding freshman repeating a department
      ];

      const history = [{ freshman: "seijihariki" }];
    }
  }
};
</script>

<style lang="scss">
button.pa-0.v-btn {
  min-width: 0;
}
</style>
